stages:
  - build
  - coverage
  - linter
  - mythril

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
  - node_modules/
  - build/

truffle:
  image: node:8
  stage: build
  script:
    - npm install
    - npm install -g truffle@4.1.14
    - npm install -g ganache-cli
    - truffle compile
    - ganache-cli > /dev/null &
    - truffle test

coverage:
  image: node:8
  stage: build
  script:
    - npm install
    - npm install -g truffle@4.1.14
    - npm install -g ganache-cli
    - node_modules/.bin/solidity-coverage

solium:
  image: node:8
  stage: build
  script:
    - npm install -g solium
    - solium -d contracts/

mythril:  
  image: sharathkumaranbu/mythril-ci  
  stage: build  
  script:    
    - myth --truffle